<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- Category List
     =============
-->

<xsl:import href='gjsTree.xsl' />
<xsl:include href='ServerLink.xsl' />


<xsl:template match="/ServerLink/Rows">
  <div id='divFolderHeadingCaption'>
    Access Rights
  </div>
  <div id='divMainHead'>
    <xsl:call-template name='divMainHead' />
  </div>
  <xsl:call-template name='gjs:tree' />
</xsl:template>


<xsl:template name='divMainHead'>

  	<table class='layoutTable' gjsTreeId='AccessRight_List'>
  	  <tr>

        <xsl:call-template name='gjs:treeMoresMainHeading' />

        <td width='25' class="iconCell"></td>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/>
          <xsl:with-param name='columnId'>AccessRight</xsl:with-param>
          <xsl:with-param name='caption'>Access Right</xsl:with-param>         
          <xsl:with-param name='selected'>ascending</xsl:with-param>
					<xsl:with-param name='previousColumnResizable'>0</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"300"'/>
          <xsl:with-param name='columnId'>Description</xsl:with-param>
          <xsl:with-param name='caption'>Description</xsl:with-param>         
        </xsl:call-template>
  	    
        <td width='*'></td>
      </tr>
    </table>

</xsl:template>



<xsl:template name='folderContent'>
  <xsl:param name='rowId'/>

  <xsl:apply-templates select='accessRight'>
    <xsl:with-param name='rowId' select='$rowId' />
	</xsl:apply-templates>

</xsl:template>


<!-- Attributes for each folder row -->
<xsl:template name='folderRowAttributes'>
	<xsl:param name='rowId'/>

  <!-- If this is an update then use the old divReferenceHeadingId otherwise use a new unique one -->
  <xsl:variable name='divReferenceHeadingId'>
    <xsl:choose>
      <xsl:when test='rowUpdate'>
        <xsl:value-of select='rowUpdate/@divReferenceHeadingId' />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select='/ServerLink/@runId' />
        <xsl:text>_mainHead</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:attribute name='tabindex'>0</xsl:attribute>
  <xsl:attribute name='onfocus'>fnItemSelect(this);Class.fnSelect(AccessRight,this);Main.fnSetMainHead("<xsl:value-of select='$divReferenceHeadingId' />");</xsl:attribute>
  <!-- SM (07/08/2013): this.focus() works around a bug in IE (see section 'To click or not to click' in http://nemisj.com/focusable) -->
  <xsl:attribute name='onclick'>this.focus();fnItemSelect(this);Class.fnSelect(AccessRight,this)</xsl:attribute>
  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(AccessRight,this);fnContextMenu("popItem")</xsl:attribute>
  <xsl:attribute name='gjsItem'><xsl:value-of select='accessRight/@accessRight' /></xsl:attribute>
  <xsl:attribute name='gjsReferenceHeadingId'><xsl:value-of select='$divReferenceHeadingId' /></xsl:attribute>
  <xsl:attribute name='id'><xsl:value-of select='$rowId' />main</xsl:attribute>
	<xsl:if test='/ServerLink/allowedMethods/method[@name="AccessRight.fnOpen"]'>
		<xsl:attribute name='ondblclick'>AccessRight.Item.fnOpen()</xsl:attribute>
	</xsl:if>
	<xsl:if test='accessRight/@genByKey!=""'>
	  <xsl:attribute name='class'>disabledRow</xsl:attribute>
	</xsl:if>
</xsl:template>


<xsl:template match='/ServerLink/Rows/Folder/accessRight'>
  <xsl:param name='rowId'/>
	
  <td class='iconCell noHighlight' width='25px'>
    <img
     width='25px'
     height='16px'>
    <xsl:choose>
      <xsl:when test='@isTemplate="1"'>
        <xsl:attribute name='src'>vcm_template_l.gif</xsl:attribute>
      </xsl:when>
      <xsl:when test='@genByKey!=""'>
        <xsl:attribute name='src'>vcm_derived_l.gif</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name='src'>vcm_record_l.gif</xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
    </img>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <span
       nowrap='nowrap'
       gjsRowId='{$rowId}'
      >
        <xsl:value-of select='@accessRight' />
      </span>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@description' />
    </div>
  </td>
</xsl:template>


<!-- Sub-folder method -->
<xsl:template name='subFolderMethod'>
  <xsl:text>AccessRight.fnListSub</xsl:text>
</xsl:template>


<!-- Sub-folder arguments -->
<xsl:template name='subFolderArguments'>
  <xsl:param name='rowId'/>
  
	<xsl:variable name='elementMain'>
		fnElement("<xsl:value-of select='$rowId'/>main")
	</xsl:variable>
	
	<xsl:variable name='elementSub'>
		fnElement("<xsl:value-of select='$rowId'/>sub")
	</xsl:variable>

  <xsl:text>"</xsl:text><xsl:value-of select='$rowId'/><xsl:text>main"</xsl:text>
  <xsl:text>+delimiter+getAttr(</xsl:text><xsl:value-of select='$elementMain'/>,'gjsItem')
  <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>

</xsl:template>

</xsl:stylesheet>
