<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

  <!-- Audit Trail List
       ================
  -->

  <xsl:import href='gjsTree.xsl' />
  <xsl:include href='ServerLink.xsl' />



  <!-- templates divMainHead, folderContent and leafContent are in here -->
  <xsl:include href='AuditTrail_Row.xsl' />


  <!-- Column Headings -->
  <xsl:template name='divMainHead'>
    <xsl:call-template name='divMainHeadContent'/>
  </xsl:template>
  
  <!-- Attributes for each folder row -->
  <xsl:template name='folderRowAttributes'>
    <xsl:call-template name='leafRowAttributes'/>
  </xsl:template>

  <!-- Attributes for each leaf row -->
  <xsl:template name='leafRowAttributes'>

    <xsl:variable name='onfocus'>
      <xsl:text>fnItemSelect(this);</xsl:text>
      <xsl:text>Class.fnSelect(AuditTrail,this);</xsl:text>
      <xsl:text>Main.fnSetMainHead("</xsl:text>
        <xsl:value-of select='/ServerLink/@runId' />
      <xsl:text>_mainHead");</xsl:text>
    </xsl:variable>

    <xsl:variable name='onclick'>
      <xsl:text>fnItemSelect(this);</xsl:text>
    </xsl:variable>

    <!-- Get colour, use the audit trail's category, or the message's category -->
    <xsl:variable name='color'>
      <xsl:choose>
        <xsl:when test='audit'>
          <xsl:value-of select='audit/category/@color' />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select='category/@color' />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:attribute name='tabindex'>0</xsl:attribute>
    <xsl:attribute name='onfocus'><xsl:value-of select='$onfocus' /></xsl:attribute>
    <xsl:attribute name='onclick'><xsl:value-of select='$onclick' /></xsl:attribute>
    <xsl:attribute name='ondblclick'>AuditTrail.Item.fnOpen()</xsl:attribute>
    <xsl:attribute name='gjsItem'><xsl:value-of select='audit/@item' /></xsl:attribute>
    <xsl:attribute name='gjsAtLine'><xsl:value-of select='audit/@atline' /></xsl:attribute>
    <xsl:attribute name='style'>color: <xsl:value-of select='$color' /></xsl:attribute>
  </xsl:template>


</xsl:stylesheet>
