//vc/ Deltanji Component Class
//vc/ Copyright 1999,2004 George James
//vc/ Object:    Component.js
//vc/ Component: T.Component.js


	// Component Class
Component = {}


	// Initialise to no current selection
Component.Current=Disabled
Component.currentFolder = null


	// Public - Display List of items and make this the active folder
Component.fnList = function() {
	//
	var html,arguments
	//
	SelectedClass=Component
	Class.fnUnselect()
	//
	fnMessageSelecting()
	//
	// Get Component list
	arguments = getAttr(g_oSelectedFolder,'gjsItem') // Location code
	arguments += delimiter + getAttr(g_oSelectedFolder,'gjsCmaskSeq') // Component mask
	if ($('#lstSelect').scombobox('val')=='') {
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Component.fnPrepareSelectorResult','Component.fnPrepareSelector',arguments)
	} else {
		arguments += delimiter + $('#lstSelect').scombobox('val')
		arguments += delimiter + Select.fnFilters()
		parent.serverLink.fnDo('Component.fnListResult','Component.fnList',arguments)
	}
}


Component.fnListResult = function(oResult) {
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


Component.fnPrepareSelectorResult = function(oResult) {
	//
	var arguments
	//
	// Update Select toolbars
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
	// Now get the Object Version list
	if ($('#lstSelect').scombobox('val')!='') {
		arguments = getAttr(g_oSelectedFolder,'gjsItem') // Location code
		arguments += delimiter + getAttr(g_oSelectedFolder,'gjsCmaskSeq') // Component mask
		arguments += delimiter + $('#lstSelect').scombobox('val')
		arguments += delimiter + Select.fnFilters()
		// Queue the subsequent server-side call rather than invoking it directly, otherwise it happens before an already-queued reset of the wait-cursor
		setTimeout('parent.serverLink.fnDo("Component.fnListResult","Component.fnList",' + arguments.quote() + ')',0);
	}
}


	// Public - Transfer Component
Component.fnTransfer = function(sObject,sFunction,sLcode1,sLcode2,sCtype,sFullName) {
	var url
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + encodeURIComponent((sFunction=='REGISTER')?'Component.fnRegister':'Component.fnTransfer')
	url += '&function=' + encodeURIComponent(sFunction)
	url += '&obv=' + encodeURIComponent(sObject)
	url += '&lcode1=' + encodeURIComponent(sLcode1)
	url += '&lcode2=' + encodeURIComponent(sLcode2)
	url += '&ctype=' + encodeURIComponent(sCtype)
	url += '&component=' + encodeURIComponent(sFullName)
	url += '&obvType=COMPONENT'
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) 
	winTransfer.focus()
}


	// Private - Transfer Component via drag/drop
Component.fnTransferDnD = function(sFunction,sLcode1,sLcode2,sCret,sObject) {
	var url
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + encodeURIComponent((sFunction=='REGISTER')?'Component.fnRegister':'Component.fnTransfer')
	url += '&function=' + encodeURIComponent(sFunction)
	url += '&obv=' + encodeURIComponent(sObject)
	url += '&lcode1=' + encodeURIComponent(sLcode1)
	url += '&lcode2=' + encodeURIComponent(sLcode2)
	url += '&cret=' + encodeURIComponent(sCret)
	url += '&obvType=COMPONENT'
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) 
	winTransfer.focus()
}


	// Public - Transfer Component Selection
Component.fnTransferMultiple = function(sFunction,sLcode1,sLcode2) {
	// Instead of using default fnInvokeOnSelection() we play special tricks here
	// to ensure that a component selection from a multi-version location (e.g. library)
	// acts on the chosen objectversions. See VCMB202.
	// This renders obsolete the logic in frameMain^%Serenj720 that tries to do the same
	// (its flaw is that it always picks the highest obv bearing the component)
	
	var sSelType='COMPONENT';
	var sItemList;
	var sCallback='Component.fnTransferMultipleDo';
	var sArgs;
	var oEl;
	var iObjectCount=0;
	var sObjectItems='';
	var iComponentCount=0;
	var sComponentItems='';
	var sDelim='\002';

  // Scan selection, gathering those with gjsObjectVersion and those without
  // This corresponds to registered and unregistered

	if (typeof(Component.selectedCells)=='object') {
		for (var i=0; i<Component.selectedCells.length; i++) {
			if (Component.selectedCells[i]!=null) {
				oEl=fnElement(Component.selectedCells[i]);
				if (oEl!=null) {
				  if (getAttr(oEl,'gjsObjectVersion')=='') {
  					iComponentCount++;
  					sComponentItems=sComponentItems+sDelim+getAttr(oEl,'gjsItem');
					}
					else {
  					iObjectCount++;
  					sObjectItems=sObjectItems+sDelim+getAttr(oEl,'gjsObjectVersion');
          }
				}
			}
		}
	}
	
	// If any are registered, submit them as an object selection
	// The unregistered selected items will be ignored
	if (iObjectCount>0) {
    sSelType='O';
    sItemList=iObjectCount+sObjectItems;
  }
  else {
    sItemList=iComponentCount+sComponentItems;
  }
  
	sArgs='"'+sFunction+'","'+sLcode1+'","'+sLcode2+'"';
	
	parent.serverLink.fnDo('fnInvokeOnSelectionResult','Selection.fnSave',sSelType+delimiter+sItemList+delimiter+sCallback+delimiter+sArgs);
}


	// Private - Transfer Component Selection
Component.fnTransferMultipleDo = function(iSelKey,sFunction,sLcode1,sLcode2) {
	var url
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + encodeURIComponent((sFunction=='REGISTER')?'Component.fnRegister':'Component.fnTransfer')
	url += '&function=' + encodeURIComponent(sFunction)
	url += '&lcode1=' + encodeURIComponent(sLcode1)
	url += '&lcode2=' + encodeURIComponent(sLcode2)
	url += '&user=' + encodeURIComponent(user)
	url += '&obvType=SEL'
	url += '&obv=' + encodeURIComponent(iSelKey)
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) 
	winTransfer.focus()
}


	// Public - Compare Component with its predecessor using Beyond Compare
Component.fnBCompare = function(sCret1,sObject1,sLcode1,sCret2,sObject2,sLcode2) {
	//
	var arguments
	//
	if (sObject1=='') { alert("Component not registered"); return }
	if (sLcode1=='') { alert("No location"); return }
	//
	arguments = sCret1
	arguments += delimiter + sObject1
	arguments += delimiter + sLcode1
	if (typeof(sCret2)!='undefined') {
		arguments += delimiter + sCret2
		if (typeof(sObject2)!='undefined') {
			if (sObject2=='') { alert("Second component not registered"); return }
			arguments += delimiter + sObject2
			if (typeof(sLcode2)!='undefined') {
				if (sLcode2=='') { alert("No location for second component"); return }
				arguments += delimiter + sLcode2
			}
		}
	}

	 // Build url string
	var url = parent.serverUrl;
	url += '&page=' + encodeURIComponent('Component.fnBCompare.raw');
	url += '&arguments=' + encodeURIComponent(arguments);

	// Build properties string
	var windowProperties  = 'left=50,top=30,width=50,height=50,toolbar=no';
	windowProperties += ',location=no,directories=no,status=no,resizable=no,menubar=no';

	// Open report window (always in a new window)
	winPage = window.open(url, 'ComponentfnBCompare', windowProperties);
}


	// Public - Unregister Component (Remove Component from Object)
Component.fnUnregister = function(sLcode,sObject,sCret) {
	//
	var yn,arguments
	//
	if (sObject=='') { alert("Component not registered"); return }
	//
	yn=confirm("Are you sure you want to unregister " + sCret + " from the object "+sObject+" at "+sLcode+" ?")
	if (!yn) return
	//
	arguments = sLcode
	arguments += delimiter + sObject
	arguments += delimiter + sCret
	parent.serverLink.fnDo('Component.fnUnregisterResult','Component.fnUnregister',arguments)
}


Component.fnUnregisterResult = function(oResult) {
	AuditTrail.fnAppendMessages(oResult)
	fnRefreshSelected()
}


	// Public - Delete Unregistered Component
Component.fnDelete = function(sLcode,sCret,sFullName) {
	//
	var yn,arguments
	//
	yn=confirm("Are you sure you want to DELETE the component " + sCret + " at "+sLcode+" ?"
		+ "\n\nContinuing will PERMANENTLY delete the following component:\n\n\t"
		+ sFullName
		+ "\n\nThis operation cannot be undone by Deltanji.")
	if (!yn) return
	//
	arguments = sLcode
	arguments += delimiter + sCret
	parent.serverLink.fnDo('Component.fnDeleteResult','Component.fnDelete',arguments)
}


Component.fnDeleteResult = function(oResult) {
	AuditTrail.fnAppendMessages(oResult)
	fnRefreshSelected()
}


  // Refresh component(s)
Component.fnRefreshArguments = function(oMain)   {
  //
  var arguments=""
  //
  arguments +=          getAttr(oMain,'gjsParentId')
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,'gjsLocation')
	arguments += '\002' + getAttr(oMain,'gjsObjectVersion')
	arguments += '\002' + getAttr(oMain,'gjsShowObv')
	arguments += '\002' + getAttr(oMain,'gjsShortName')
	arguments += '\002' + getAttr(oMain,'gjsCtype')
	arguments += '\002' + getAttr(oMain,'gjsCname')
	arguments += '\002' + getAttr(oMain,'gjsRowId')
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId')
  //
	return arguments
}


  // Refresh component(s)
Component.fnRefresh = function(arguments)   {
  ServerLink.fnDo('Component.fnRefreshResult','Component.fnRefresh',arguments)
}

Component.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}


	// Handle for selected item methods
Component.Item = {
 
	// Public - Transfer selected Component
 fnTransfer: function(sFunction,sLcode1,sLcode2) {
	//
	var sCtype,sCname,sObject
	//
	if (typeof(Component.Current)=='undefined') return
	if (Class.fnSelectionCount()==1) {
    sObject=getAttr(Component.selectedCell,'gjsObjectVersion')
		sCtype=getAttr(Component.selectedCell,'gjsCtype')
		sCname=getAttr(Component.selectedCell,'gjsCname')
		Component.fnTransferDnD(sFunction,sLcode1,sLcode2,sCtype + "." + sCname,sObject)
	}
	else {
		Component.fnTransferMultiple(sFunction,sLcode1,sLcode2)
	}
 },

	// Public - Unregister or Delete Component at location
 fnUnregisterOrDelete: function() {
	//
	var sLcode, sObject, sComponent, cCtype, sStatus, sFullName
	//
	if (typeof(Component.Current)=='undefined') return
	sLcode=getAttr(Component.selectedCell,'gjsLocation')	
	sObject=getAttr(Component.selectedCell,'gjsObjectVersion')
	sComponent=getAttr(Component.selectedCell,'gjsCname')
	sCtype=getAttr(Component.selectedCell,'gjsCtype')
	sStatus=getAttr(Component.selectedCell,'gjsItemStatus')
	sFullName=getAttr(Component.selectedCell,'gjsFullName')
	if (sStatus=="C") {
		Component.fnUnregister(sLcode,sObject,sCtype+'.'+sComponent)
	}
	else if (sStatus=="U") {
		Component.fnDelete(sLcode,sCtype+'.'+sComponent,sFullName)
	}
	else {
		alert("Unregister the component before deleting")
	}
 },

	// Public - Delete Component at location
 fnDelete: function() {
	//
	var sLcode, sComponent, cCtype, sStatus, sFullName
	//
	if (typeof(Component.Current)=='undefined') return
	sLcode=getAttr(Component.selectedCell,'gjsLocation')	
	sComponent=getAttr(Component.selectedCell,'gjsCname')
	sCtype=getAttr(Component.selectedCell,'gjsCtype')
	sStatus=getAttr(Component.selectedCell,'gjsItemStatus')
	sFullName=getAttr(Component.selectedCell,'gjsFullName')
	if (sStatus=="U") {
		Component.fnDelete(sLcode,sCtype+'.'+sComponent,sFullName)
	} else {
		alert("Unregister the component before deleting")
	}
 },

	// Public - Should Delete menu option be offered?
 fnDelete$MenuState: function() {
  if (Class.fnSelectionCount()!=1) return false;
	if (getAttr(Component.selectedCell,'gjsItemStatus')!="U") return false;
	return true;
 },


	// Public - Register component(s) as new object(s) at location
 fnRegister:function() {
	//
	if (typeof(Component.Current)=='undefined') return
	Component.Current.fnTransfer("REGISTER",getAttr(Component.selectedCell,'gjsLocation'),"")
 },

	// Public - Should Register menu option be offered?
 fnRegister$MenuState: function() {
	var oEl
	if (Class.fnSelectionCount()>1) {
		for (var i=0; i<Component.selectedCells.length; i++) {
			if (Component.selectedCells[i]!=null) {
				oEl=fnElement(Component.selectedCells[i]);
				if (oEl!=null) {
				  if (getAttr(oEl,'gjsItemStatus')!='U') return false;
				}
			}
		}
	}
	else if (getAttr(Component.selectedCell,'gjsItemStatus')!="U") return false;
	return true;
 },
 
	// Public - Unregister component from object at location
 fnUnregister: function() {
	//
	var sLcode, sObject, sComponent, cCtype, cStatus
	//
	if (typeof(Component.Current)=='undefined') return
	//
	sLcode=getAttr(Component.selectedCell,'gjsLocation')	
	sObject=getAttr(Component.selectedCell,'gjsObjectVersion')
	sComponent=getAttr(Component.selectedCell,'gjsCname')
	sCtype=getAttr(Component.selectedCell,'gjsCtype')
	sStatus=getAttr(Component.selectedCell,'gjsItemStatus')
	if (sStatus=="C") {
		Component.fnUnregister(sLcode,sObject,sCtype+'.'+sComponent)
	}	
	else if (sStatus=="U") {
		alert("Component not registered")
	}	
	else {
		alert("Check out the owning object "+sObject+" before unregistering")
	}	
 },
 
	// Public - Should Unregister menu option be offered?
 fnUnregister$MenuState: function() {
  if (Class.fnSelectionCount()!=1) return false;
	if (getAttr(Component.selectedCell,'gjsItemStatus')!="C") return false;
	return true;
 },

	// Public - Compare component from object at location (or pair)
 fnBCompare: function() {
	var oEl,sCret1,sObv1,sLcode1,sCret2,sObv2,sLcode2
	//
	if (typeof(Component.Current)=='undefined') return
	//
	if (Class.fnSelectionCount()==1) {
		oEl=Component.selectedCell;
		sCret1=getAttr(oEl,'gjsCtype')+'.'+getAttr(oEl,'gjsCname');
		sObv1=getAttr(oEl,'gjsObjectVersion');
		sLcode1=getAttr(oEl,'gjsLocation');
		if (getAttr(oEl,'gjsItemStatus')=='U') {
			alert("Component not registered")
		}
		else {
			Component.fnBCompare(sCret1,sObv1,sLcode1);
		}
	}
	else if (Class.fnSelectionCount()==2) {
		oEl=fnElement(Component.selectedCells[0]);
		sCret1=getAttr(oEl,'gjsCtype')+'.'+getAttr(oEl,'gjsCname');
		sObv1=getAttr(oEl,'gjsObjectVersion');
		sLcode1=getAttr(oEl,'gjsLocation');
		if (getAttr(oEl,'gjsItemStatus')=='U') {
			alert("Component not registered")
		}
		else {
			oEl=fnElement(Component.selectedCells[1]);
			sCret2=getAttr(oEl,'gjsCtype')+'.'+getAttr(oEl,'gjsCname');
			sObv2=getAttr(oEl,'gjsObjectVersion');
			sLcode2=getAttr(oEl,'gjsLocation');
			if (getAttr(oEl,'gjsItemStatus')=='U') {
				alert("Component not registered")
			}
			else {
				Component.fnBCompare(sCret1,sObv1,sLcode1,sCret2,sObv2,sLcode2);
			}
		}
	}
 },

	// Public - Should Compare menu option be offered?
 fnBCompare$MenuState: function() {
  if (Class.fnSelectionCount()==0) return false;
  if (Class.fnSelectionCount()==1) return (getAttr(Component.selectedCell,'gjsItemStatus')!="U");
  if (Class.fnSelectionCount()>2) return false;
  if (getAttr(fnElement(Component.selectedCells[0]),'gjsItemStatus')=='U') return false;
  if (getAttr(fnElement(Component.selectedCells[1]),'gjsItemStatus')=='U') return false;
  return true;
 },

	// Public - Cancel object owning component at location
 fnCancel: function() {
	//
	var sObject, cStatus
	//
	if (typeof(Component.Current)=='undefined') return
	//
	if (Class.fnSelectionCount()==1) {
  	sObject=getAttr(Component.selectedCell,'gjsObjectVersion')
  	sStatus=getAttr(Component.selectedCell,'gjsItemStatus')
  	if (sStatus=="C") {
  		Object.fnCancel(sObject)
  	}	
  	else {
  		alert("Cancel only valid for checked out object")
  	}
  } else {
  		alert("Cancel only supported with single component selection")
  }	
 },

	// Public - Should Cancel menu option be offered?
 fnCancel$MenuState: function() {
  if (Class.fnSelectionCount()!=1) return false;
  if (getAttr(Component.selectedCell,'gjsItemStatus')!="C") return false;
  return true;
 },

	// Public - Add item to worklist
 fnWorkListCopy: function() {
	fnWorkListCopy()
 },

	// Public - Add item to worklist as object
 fnWorkListCopyAsObject: function() {
	var i;
	var oEl;
	for (i=0; i<SelectedClass.selectedCells.length; i++) {
		oEl=fnElement(SelectedClass.selectedCells[i]);
		if ((oEl!=null) && (typeof(getAttr(oEl,'gjsObjectVersion'))!='undefined')) fnWorkListAdd(getAttr(oEl,'gjsObjectVersion'),'OBJECT');
	}
 }
}
