@echo off

rem This command file converts the vcmConfiguration.xml file into a global save file that can
rem be loaded into VC/m using a global restore utility.
rem
rem You must have Java 1.4 or later installed in order to be able to run these commands.
rem
rem From Java 5 onwards you need to fetch xalan.jar and its associated serializer.jar
rem by downloading from http://xml.apache.org/xalan-j/
rem As at May 2007 the version is 2.7.0.
rem Download xalan-j_2_7_0-bin.zip and unzip it. Copy xalan.jar and serializer.jar
rem from the unzipped directory into the one where this .bat file resides.
rem
rem Xalan is part of Java 1.4, so the additional jars are not required. But you must
rem either remove the following lines that check for the xalan.jar file, or download
rem them anyway (they should work okay on 1.4).

if not exist xalan.jar (
	echo **Cannot proceed -- xalan.jar missing.
	echo   To correct the problem, read comments in this .bat file for instructions.
	goto error
)

if exist vcmConfigurationPass1.xml del vcmConfigurationPass1.xml
if exist vcmConfigurationPass2.xml del vcmConfigurationPass2.xml
if exist vcmConfiguration.g del vcmConfiguration.g

echo Processing vcmConfiguration.xml...
java -cp "xalan.jar" org.apache.xalan.xslt.Process -in vcmConfiguration.xml -xsl vcmConfiguration.xml#xsl -out vcmConfigurationPass1.xml
if not errorlevel 0 goto error
echo vcmConfigurationPass1.xml created.

echo Processing vcmConfigurationPass1.xml...
java -cp "xalan.jar" org.apache.xalan.xslt.Process -in vcmConfigurationPass1.xml -xsl vcmConfiguration.xml#xsl -out vcmConfigurationPass2.xml
if not errorlevel 0 goto error
echo vcmConfigurationPass2.xml created.
   
echo Processing vcmConfigurationPass2.xml...
java -cp "xalan.jar" org.apache.xalan.xslt.Process -in vcmConfigurationPass2.xml -xsl vcmConfigurationXmlToG.xsl -out vcmConfiguration.g -text
if not errorlevel 0 goto error
echo vcmConfiguration.g created.
echo Done.
goto done

:error
echo Aborted.

:done
pause
