<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="environmentSet"/>
</xsl:template>

<xsl:template match="environmentSet">

<gjs:form
 title='Environment Settings'
 jsFile='vcset72.js'
 onload='frmMain.programFiles.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Environment settings.
  </gjs:information>

<div id='divEnvironmentSet' class='visible' style='min-height: 200px'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='200'/>
    <gjs:column width='270'/>
  </gjs:columnWidths>

  <gjs:fields>
   
    <gjs:input
     id='programFiles'
     accesskey='F'
     size='40'
     maxlength='2000'
     value='{@programFiles}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Directory where application <u>f</u>iles are held</label>
     <hint>Enter a directory</hint>
    </gjs:input>

    <gjs:input
     id='perlCommand'
     accesskey='R'
     size='40'
     maxlength='2000'
     value='{@perlCommand}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Path and file name for Pe<u>r</u>l interpreter</label>
     <hint>Enter a path</hint>
    </gjs:input>

    <tr><td height='16'></td></tr>
 
    <tr><td><label><b>Platform-Specific Settings</b></label></td></tr>

    <tr>
     
    <xsl:apply-templates select="/Form/environmentSet/checkbox" mode='grid'>
                <xsl:with-param name='name'/>
		<xsl:with-param name='value'/>
              </xsl:apply-templates>
    </tr>

    <gjs:input
     id='temp'
     accesskey='T'
     size='40'
     maxlength='2000'
     value='{@temp}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Cache: <u>T</u>emporary file directory</label>
     <hint>Enter a directory</hint>
    </gjs:input>

    <gjs:input
     id='nounixaccess'
     accesskey='X'
     size='30'
     maxlength='30'
     value='{@nounixaccess}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>MSM on UNI<u>X</u>: Give users permission to run UNIX shell scripts</label>
     <hint>Enter permission</hint>
    </gjs:input>

    <gjs:input
     id='unixReadWrite'
     accesskey='M'
     size='30'
     maxlength='30'
     value='{@unixReadWrite}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>UNIX <u>m</u>ode setting for read /write files</label>
     <hint>Enter mode</hint>
    </gjs:input>

    <gjs:input
     id='unixReadOnly'
     accesskey='N'
     size='30'
     maxlength='30'
     value='{@unixReadOnly}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>U<u>N</u>IX mode setting for read-only files</label>
     <hint>Enter mode</hint>
    </gjs:input>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

<xsl:template match='checkbox' name='checkbox' mode="grid">
  <xsl:param name='checkbox'/>
     <td>
      <label>DSM: Use VMS file deletion protection</label>
     </td>
     <td>
      <xsl:choose>
        <xsl:when test='@value="1"'>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
           accesskey='R'
           onclick='Form.fnChanged()'
           checked='checked' />
        </xsl:when>
        <xsl:otherwise>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
           onclick='Form.fnChanged()'
           accesskey='R' />
        </xsl:otherwise>
      </xsl:choose>
    </td>
</xsl:template>

</xsl:stylesheet>
