﻿<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- Variables List
     =========
-->

<xsl:import href='gjsTree.xsl' />
<xsl:include href='ServerLink.xsl' />


<xsl:template match="/ServerLink/Rows">
  <div id='divFolderHeadingCaption'>
    Variables
  </div>
  <div id='divMainHead'>
    <xsl:call-template name='divMainHead' />
  </div>
  <xsl:call-template name='gjs:tree' />
</xsl:template>


<xsl:template name='divMainHead'>

  	<table class='layoutTable' width='1000px' gjsTreeId='Variable_List'>
  	  <tr>

        <xsl:call-template name='gjs:treeMoresMainHeading' />

        <td width='25'></td>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"120"'/> 
	  <xsl:with-param name='columnId'>Variable</xsl:with-param>
          <xsl:with-param name='caption'>Variable</xsl:with-param>         
          <xsl:with-param name='selected'>ascending</xsl:with-param>
	  <xsl:with-param name='previousColumnResizable'>0</xsl:with-param>
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"200"'/> 
	  <xsl:with-param name='columnId'>Description</xsl:with-param>
          <xsl:with-param name='caption'>Description</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"200"'/> 
	  <xsl:with-param name='columnId'>Values</xsl:with-param>
          <xsl:with-param name='caption'>Number of Values</xsl:with-param>         
        </xsl:call-template>
        
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"1000"'/> 
        </xsl:call-template>
  	    
        <td width='*'></td>
      </tr>
    </table>

</xsl:template>


<xsl:template name='folderContent'>
  <xsl:param name='rowId'/>

  <xsl:apply-templates select='variable'>
    <xsl:with-param name='rowId' select='$rowId' />
	</xsl:apply-templates>

</xsl:template>


<!-- Attributes for each folder row -->
<xsl:template name='folderRowAttributes'>
	<xsl:param name='rowId'/>

  <!-- If this is an update then use the old divReferenceHeadingId otherwise use a new unique one -->
  <xsl:variable name='divReferenceHeadingId'>
    <xsl:choose>
      <xsl:when test='rowUpdate'>
        <xsl:value-of select='rowUpdate/@divReferenceHeadingId' />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select='/ServerLink/@runId' />
        <xsl:text>_mainHead</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:attribute name='tabindex'>0</xsl:attribute>
  <xsl:attribute name='onfocus'>fnItemSelect(this);Class.fnSelect(Variable,this);Main.fnSetMainHead("<xsl:value-of select='$divReferenceHeadingId' />");</xsl:attribute>
  <xsl:attribute name='onclick'>fnItemSelect(this);Class.fnSelect(Variable,this)</xsl:attribute>
  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(Variable,this);fnContextMenu("popItem")</xsl:attribute>
  <xsl:attribute name='gjsItem'><xsl:value-of select='variable/@variable' /></xsl:attribute>
  <xsl:attribute name='gjsReferenceHeadingId'><xsl:value-of select='$divReferenceHeadingId' /></xsl:attribute>
  <xsl:attribute name='id'><xsl:value-of select='$rowId' />main</xsl:attribute>
	<xsl:if test='/ServerLink/allowedMethods/method[@name="Variable.fnOpen"]'>
		<xsl:attribute name='ondblclick'>Variable.Item.fnOpen()</xsl:attribute>
	</xsl:if>
</xsl:template>


<xsl:template match='/ServerLink/Rows/Folder/variable'>
  <xsl:param name='rowId'/>
	
  <td class='noHighlight' width='25px'>
    <img
     src='vcm_record_l.gif'
     width='25px'
     height='16px'>
    </img>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <span
       nowrap='nowrap'
       gjsRowId='{$rowId}'
      >
        <xsl:value-of select='@variable' />
      </span>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@description' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@values'/>    
    </div>
  </td>

  <!-- empty cell to cater for extra column that gives the last real column a right-hand resize handle -->
  <td class='treeCell'>
    <div nowrap='nowrap'>
    </div>
  </td>
</xsl:template>


<!-- Sub-folder method -->
<xsl:template name='subFolderMethod'>
  <xsl:text>Variable.fnListSub</xsl:text>
</xsl:template>


<!-- Sub-folder arguments -->
<xsl:template name='subFolderArguments'>
  <xsl:param name='rowId'/>
  
	<xsl:variable name='elementMain'>
		fnElement("<xsl:value-of select='$rowId'/>main")
	</xsl:variable>
	
	<xsl:variable name='elementSub'>
		fnElement("<xsl:value-of select='$rowId'/>sub")
	</xsl:variable>

  <xsl:text>"</xsl:text><xsl:value-of select='$rowId'/><xsl:text>main"</xsl:text>
  <xsl:text>+delimiter+getAttr(</xsl:text><xsl:value-of select='$elementMain'/><xsl:text>,"gjsItem")</xsl:text>
  <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>

</xsl:template>

</xsl:stylesheet>
