<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="webInterfaceSet"/>
</xsl:template>

<xsl:template match="webInterfaceSet">


<gjs:form
 title='Browser Interface Settings'
 jsFile='vcset80.js'
 onload='frmMain.siteTitle.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Browser interface settings.
  </gjs:information>

<div id='divEnvironmentSet' class='visible' style='height: 170px;'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='245'/>
    <gjs:column width='350'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='siteTitle'
     accesskey='T'
     size='46'
     maxlength='2000'
     value='{@siteTitle}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Site <u>t</u>itle</label>
     <hint>Enter a title</hint>
    </gjs:input>

    <gjs:input
     id='browserUrl'
     accesskey='U'
     size='46'
     maxlength='2000'
     value='{@browserUrl}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>U</u>RL</label>
     <hint>Enter a URL</hint>
    </gjs:input>

    <gjs:input
     id='webMaxObjects'
     accesskey='B'
     size='4'
     maxlength='4'
     value='{@webMaxObjects}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Maximum number of items in <u>b</u>rowser display</label>
     <hint>Enter a number</hint>
    </gjs:input>

    <gjs:input
     id='webMaxAudit'
     accesskey='A'
     size='4'
     maxlength='4'
     value='{@webMaxAudit}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Maximum number of <u>a</u>udit entries in browser display</label>
     <hint>Enter a number</hint>
    </gjs:input>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

</xsl:stylesheet>
