<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- gJax Toolbar
     ============
-->

<xsl:include href='ServerLink.xsl' />
<xsl:include href='gjsControls.xsl' />

<xsl:template match="/ServerLink/Toolbars">
  <div id='divSelect'>
    <xsl:call-template name='toolbarStandard'/>
    <xsl:call-template name='toolbarDebug'/>
  </div>
</xsl:template>


<!-- Standard Home/New/Open toolbar -->
<xsl:template name='toolbarStandard'>

	<xsl:variable name='txtHome'>
		<xsl:call-template name='gjs:translateString'>
			<xsl:with-param name='string' select='"cmdHome"'/>
			<xsl:with-param name='default' select='"Go to Home"'/>
			<xsl:with-param name='language' select='preferences/@language'/>
			<xsl:with-param name='dictionary' select='"gjaxToolbar_Dictionary.xml"'/>
		</xsl:call-template>
	</xsl:variable>

	<xsl:variable name='txtNew'>
		<xsl:call-template name='gjs:translateString'>
			<xsl:with-param name='string' select='"cmdNew"'/>
			<xsl:with-param name='default' select='"Create new item"'/>
			<xsl:with-param name='language' select='preferences/@language'/>
			<xsl:with-param name='dictionary' select='"gjaxToolbar_Dictionary.xml"'/>
		</xsl:call-template>
	</xsl:variable>

	<xsl:variable name='txtOpen'>
		<xsl:call-template name='gjs:translateString'>
			<xsl:with-param name='string' select='"cmdOpen"'/>
			<xsl:with-param name='default' select='"Open selected item"'/>
			<xsl:with-param name='language' select='preferences/@language'/>
			<xsl:with-param name='dictionary' select='"gjaxToolbar_Dictionary.xml"'/>
		</xsl:call-template>
	</xsl:variable>
  <div id='divToolbarStandard' style='position: absolute; top: 0; left: 0; width: 100;'>

  <!-- Include dummy, hidden lstSelect object for select arguments -->
  <input 
   type='hidden'
   name='lstSelect'
   value=''/>

   <table
     width='100px'
     border='0'>
      <tr>
        <xsl:call-template name='handle'/>
       <td>
          <img 
           style='border: 1px solid buttonface' 
           onmouseover='this.style.border="1px inset threedshadow"' 
           onmouseout='this.style.border="1px solid buttonface"' 
           id="cmdHome" 
           title="{$txtHome}" 
           onclick="Main.fnWelcome(); divMainHead.innerHTML=''; fnFolderClear()" />
        </td>
       <td>
          <img 
           style='border: 1px solid buttonface' 
           onmouseover='this.style.border="1px inset threedshadow"' 
           onmouseout='this.style.border="1px solid buttonface"' 
           id="cmdNew" 
           title="{$txtNew}" 
           onclick="try {{SelectedClass.fnNew()}} catch(e) {{}}" />
        </td>
       <td>
          <img 
           style='border: 1px solid buttonface' 
           onmouseover='this.style.border="1px inset threedshadow"' 
           onmouseout='this.style.border="1px solid buttonface"' 
           id="cmdOpen" 
           title="{$txtOpen}" 
           onclick="try {{SelectedClass.Current.fnOpen()}} catch (e) {{}}" />
        </td>
     </tr>
    </table>

  </div>
</xsl:template>


<!-- Debugging toolbar -->
<xsl:template name='toolbarDebug'>
  <div id='divToolbarDebug' style='float: right'>

		<table
     width='100px'
     border='0'>
      <tr>
        <xsl:call-template name='handle'/>
				<td>
					<gjs:caption
					 readonly='0'
					 id='debug'
					 gjaxDictionary='gjaxToolbar_Dictionary.xml'
					 language='{preferences/@language}'>
						<label>Debug:</label>
					</gjs:caption>				
				</td>

				<td>
					<gjs:trigger
					 id='cmdDebugOn'					 
					 onclick='Session.fnDebugOn()'
					 gjaxDictionary='gjaxToolbar_Dictionary.xml'
					 language='{preferences/@language}'>
					  <label><u>D</u>is is xsl</label>
					  <hint>Click here to disable server-side debugging using Serenji</hint>
					</gjs:trigger>
				</td>
				<td>
					<gjs:trigger
					 id='cmdDebugOff'
					 disabled='disabled'
					 onclick='Session.fnDebugOff()'
					 gjaxDictionary='gjaxToolbar_Dictionary.xml'
					 language='{preferences/@language}'>
					  <label><u>D</u>isable</label>
					  <hint>Click here to disable server-side debugging using Serenji</hint>
					</gjs:trigger>
				</td>
			</tr>
		</table>

  </div>
</xsl:template>


<!-- Draw a handle (passive, no behaviour) -->
<xsl:template name='handle'>
  <td
   width='3'
   class='disabled'
   style='padding-left: 0; border-left: 0; padding-top: 3; padding-right: 0;'>
    <div
     class='disabled'
     style='left: 3; width: 3; border-left: 1 solid buttonhighlight; border-right: 1 solid buttonshadow; border-top: 1 solid buttonhighlight; border-bottom: 1 solid buttonshadow; padding: 0; margin: 0; margin-top: 1; margin-bottom: 4'>
    </div>
  </td>

  <td
   width='10'>
  </td>
</xsl:template>


</xsl:stylesheet>
